<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;

class PatientRedFlagForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('patient', HiddenType::class, array(
                'attr' => array(
                    'value' => $options['patient_id']
                )
            ))
            ->add('id', HiddenType::class)
            ->add('red_flag_note', TextareaType::class, array(
                'label' => 'Notes',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => false,
                'attr' => array(
                    'rows' => 5
                )
            ))
            ->add('isGreenFlag', CheckboxType::class, array(
                'label' => 'Green',
                'required' => false
            ))
            ->add('isYellowFlag', CheckboxType::class, array(
                'label' => 'Yellow',
                'required' => false
            ))
            ->add('isRedFlag', CheckboxType::class, array(
                'label' => 'Red',
                'required' => false
            ))
            ->add('isBlueFlag', CheckboxType::class, array(
                'label' => 'Blue',
                'required' => false
            ))
			->add('isPurple', CheckboxType::class, [
			    'required'   => false,
			    'label'      => 'Purple',
			])
			->add('isOrange', CheckboxType::class, [
			    'required'   => false,
			    'label'      => 'Orange',
			])
			->add('isLightBlue', CheckboxType::class, [
			    'required'   => false,
			    'label'      => 'Light blue',
			])
			->add('isPink', CheckboxType::class, [
			    'required'   => false,
			    'label'      => 'Pink',
			])
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {

                $form = $event->getForm();
                $data = $event->getData();

                $form
                    ->add('start_date', TextType::class, array(
                        'label' => 'Start Date',
                        'label_attr' => array(
                            'class' => 'required middle'
                        ),
                        'required' => true,
                        'attr' => array(
                            'class' => 'date'
                        ),
                        'data' => $data ? $data->getStartDateAsString() : ''
                    ))
                    ->add('end_date', TextType::class, array(
                        'label' => 'End Date',
                        'label_attr' => array(
                            'class' => 'middle'
                        ),
                        'required' => false,
                        'attr' => array(
                            'class' => 'date'
                        ),
                        'data' => $data ? $data->getEndDateAsString() : ''
                    ));
            });
        $builder->get('patient')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:PatientEntity', true));
    }

    public function getBlockPrefix()
    {
        return 'patientRedFlag';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\PatientRedFlagEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'patientRedFlagEntity_intention',
            'action'          => 'n',
            'patient_id'      => null
        ));
    }
}